Codeforces Round #361 (Div. 2) C. Mike and Chocolate Thieves【二分】

Bad news came to Mike’s village, some thieves stole a bunch of chocolates from the local factory! Horrible!
Aside from loving sweet things, thieves from this area are known to be very greedy. So after a thief takes his number of chocolates for himself, the next thief will take exactly k times more than the previous one. The value of k (k > 1) is a secret integer known only to them. It is also known that each thief’s bag can carry at most n chocolates (if they intend to take more, the deal is cancelled) and that there were exactly four thieves involved.
Sadly, only the thieves know the value of n, but rumours say that the numbers of ways they could have taken the chocolates (for a fixed n, but not fixed k) is m. Two ways are considered different if one of the thieves (they should be numbered in the order they take chocolates) took different number of chocolates in them.
Mike want to track the thieves down, so he wants to know what their bags are and value of n will help him in that. Please find the smallest possible value of n or tell him that the rumors are false and there is no such n.
Input
The single line of input contains the integer m (1 ≤ m ≤ 1015) — the number of ways the thieves might steal the chocolates, as rumours say.
Output
Print the only integer n — the maximum amount of chocolates that thieves’ bags can carry. If there are more than one n satisfying the rumors, print the smallest one.
If there is no such n for a false-rumoured m, print  - 1.
Examples
Input
1
Output
8
Input
8
Output
54
Input
10
Output
-1
Note
In the first sample case the smallest n that leads to exactly one way of stealing chocolates is n = 8, whereas the amounts of stealed chocolates are (1, 2, 4, 8) (the number of chocolates stolen by each of the thieves).
In the second sample case the smallest n that leads to exactly 8 ways is n = 54 with the possibilities: (1, 2, 4, 8),  (1, 3, 9, 27),  (2, 4, 8, 16),  (2, 6, 18, 54),  (3, 6, 12, 24),  (4, 8, 16, 32),  (5, 10, 20, 40),  (6, 12, 24, 48).
There is no n leading to exactly 10 ways of stealing chocolates in the third sample case.

题意:给你一个n,让你求m个四项等比数列,求其最后一项最大值的是多少,如果不存在输出-1(当有一个最大值满足多个等比数列的最后一项时);
分析:
存在初值和公比两个未知量,这样考虑就被误导了。
让你求最大值,你找到最大值以内的所有排列能等于m就行了,最后一项(最大值)除以公比的三阶得到的值就是在【1,n】范围内公比q的等比数列的总数(公比相同,初项不同),所以枚举公比就行了。由于总数是个递增序列,二分最大值即可得到结果;

#include <cstdio>
typedef unsigned long long LL;

const int MAXN = 1e6 + 10;
LL p[MAXN];

inline void init() {
    LL ans = 2; //预处理所有数的三阶 
    for(int i = 0; i < MAXN; ++i) {
        p[i] = ans * ans * ans;
        ans++;
    }
}

int main() {
    LL n; init();
    scanf("%lld", &n);
    LL L = 0, R = 1e16, sum, cnt = -1; //注意端点范围 
    while(R - L > 1) {
        LL mid = (L + R) >> 1;
        sum = 0;
        for(int i = 0; i < MAXN; ++i) {
            if(mid < p[i] || sum > n) break;
            sum = sum + mid / p[i];
        }
        if(sum >= n) {
            R = mid;
            if(sum == n) cnt = mid; //保存最优结果 
        }
        else L = mid;
    }
    if(cnt > 0) printf("%lld\n", cnt);
    else printf("-1\n");
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_36368339/article/details/79873785